<?php

// # Weaver X-Plus SW Globals ==============================================================
$weaverxplus_opts_cache = false;  // internal cache for all settings


// ===============================  options =============================

function weaverxplus_getopt($opt) {
	global $weaverxplus_opts_cache;
	if (!$weaverxplus_opts_cache)
		$weaverxplus_opts_cache = get_option('weaverxplus_settings' ,array());

	if (!isset($weaverxplus_opts_cache[$opt]))    // handles changes to data structure
	  {
		return false;
	  }
	return $weaverxplus_opts_cache[$opt];
}

function weaverxplus_isset($name){
    global $weaverxplus_opts_cache;
	if ( !$weaverxplus_opts_cache )
		$weaverxplus_opts_cache = get_option('weaverxplus_settings' ,array());
    return isset($weaverxplus_opts_cache[$name]);
}

function weaverxplus_setpost_checkbox($name) {
    if (isset($_POST[$name])) weaverxplus_setopt($name, 'checked');
	else weaverxplus_setopt($name, false);
}

function weaverxplus_setopt($opt, $val, $save = true) {
	global $weaverxplus_opts_cache;
	if (!$weaverxplus_opts_cache)
		$weaverxplus_opts_cache = get_option('weaverxplus_settings' ,array());

	$weaverxplus_opts_cache[$opt] = $val;

	if ( $save )
		weaverxplus_update_opts( );
}


function weaverxplus_clear_opts() {
	global $weaverxplus_opts_cache;
	$weaverxplus_opts_cache = false;
	if ( current_user_can( 'manage_options' ) )
		delete_option( 'weaverxplus_settings' );
}


function weaverxplus_update_opts() {
    global $weaverxplus_opts_cache;
	if ( current_user_can( 'manage_options' ) ) {
		update_option('weaverxplus_settings', $weaverxplus_opts_cache );
	}
}

function weaverxplus_default_int($value, $min, $max, $default='') {
    if (!is_numeric($value) || !is_int((int)$value)) {
        return $default;
    } else {
        if ($value == '' || (int)$value < $min || (int)$value > $max)
            return $default;
        else
            return $value;
    }
}

function weaverxplus_default_dec($value, $min, $max, $default='') {
    if (!is_numeric($value)) {
        return $default;
    } else {
        if ($value == '' || $value < $min || $value > $max)
            return $default;
        else
            return $value;
    }
}

function weaverxplus_save_msg($msg) {
	echo '<div id="message" class="updated fade"><p><strong>' . $msg .
		'</strong></p></div>';
}
function weaverxplus_error_msg($msg) {
	echo '<div id="message" class="updated fade" style="background:#F88;"><p><strong>' . $msg .
		'</strong></p></div>';
}


// =============================== transient options =============================

if (!function_exists('weaverxplus_globals')) {
	function weaverxplus_globals($glb) {
        return isset($GLOBALS[$glb]) ? $GLOBALS[$glb] : '';
    }
}

if (!function_exists('weaverxplus_t_set')) {
	function weaverxplus_t_set($opt, $val) {
        $GLOBALS['weaverx_temp_opts'][$opt] = $val;
    }
}

if (!function_exists('weaverxplus_t_get')) {
	function weaverxplus_t_get($opt) {
        return isset($GLOBALS['weaverx_temp_opts'][$opt]) ? $GLOBALS['weaverx_temp_opts'][$opt] : '';
    }
}

if (!function_exists('weaverxplus_t_clear')) {
	function weaverxplus_t_clear($opt) {
        unset($GLOBALS['weaverx_temp_opts'][$opt]);
    }
}

if (!function_exists('weaverxplus_t_clear_all')) {
	function weaverxplus_t_clear_all() {
        unset($GLOBALS['weaverx_temp_opts']);
    }
}


function weaverxplus_help_link( $ref, $label) {
    $url = plugins_url( 'help/' . $ref, __FILE__ );
	$help =  '<a style="text-decoration:none;" href="' . esc_url($url) . '" target="_blank" title="' . $label . '">'
		. '<span style="color:red; vertical-align: middle; margin-left:.25em;" class="dashicons dashicons-editor-help"></span>' . '</a>';
	echo($help);
}

//======================================== runtime support filteres and actions ===============

if (defined('WEAVERX_PLUS_TEST_MODE')) {
	if (strtotime(date('Y-m-d'))<=strtotime('2015-04-28')){ // don't auto-update for testing
		remove_filter('weaverx_xtra_type', 'weaverx_xtra_type_filter');
		add_filter('weaverx_xtra_type', 'weaverxplus_xtra_type_filter');
	}
} else {
	remove_filter('weaverx_xtra_type', 'weaverx_xtra_type_filter');
	add_filter('weaverx_xtra_type', 'weaverxplus_xtra_type_filter');
}

function weaverxplus_xtra_type_filter( $type ) {
    if ( $type[0] == '+') {
        return substr($type,1);
    }
    return $type;
}

add_action('get_header','weaverxplus_get_header_action');
function weaverxplus_get_header_action() {

    if ( function_exists('weaverx_getopt') ) {
        $code = weaverx_getopt('_phpactions');
        if ($code) {
				eval($code);
			}
    }
}
add_action( 'widgets_init', 'weaverxplus_widgets_init', 11 );

function weaverxplus_widgets_init() {
	// Header Horizontal Widget area

}

function weaverxplus_add_shortcode( $sc, $func ) {
    add_shortcode( $sc, $func );
}

function weaverxplus_show_help() {
?>
<div style="clear:both;"></div>
<div class="a-plus">
<br />
<span style="color:blue;font-weight:bold; font-size: larger;"><b>Weaver Xtreme Plus Help</b></span>&nbsp;
<?php weaverxplus_help_link('plus-help.html','Help for Weaver Xtreme Plus plugin'); ?>
<p>Click the red ? to view the full Weaver Xtreme Plus help document.</p>
<br />
<h3 style="color:green;text-decoration:underline;">Shortcode Summary</h3>
<ul>
    <li><strong><code>[buttons start='first-to-show' end='last-to-show' list='1,3,2']</code></strong></li>
    <li><strong><code>[extra_menu menu_name='Menu Name' menu_style='menu-options' menu_type='accordion' class='your-class']</code></strong></li>
    <li><strong><code>[feed feed='url' items=10 show_sitename=0 show_content=1 excerpt=0 trusted=0 title_style='']</code></strong></li>
    <li><strong><code>[php]php code[/php]</code></strong></li>
    <li><strong><code>[popup_link href='url' h='height-px' w='width_px']link-content-text/image[/popup_link]</code></strong></li>
    <li><strong><code>[search class=your_class max_width=nn size=nn]</code></strong></li>
    <li><strong><code>[shortcoder id="myname" v1="optional-replacement" ... v9="replacement"]</code></strong></li>
    <li><strong><code>[showhide start='hide' show='html-on-show' hide='html-on-hide']text[/showhide]</code></strong></li>
    <li><strong><code>[social font_size=nn number='showcount' tag='wrap-tag' color=#000000]</code></strong></li>
    <li><strong><code>[widget_area area='area-name' area_style='area-style-name' class='alt-class-name' style='inline-style-rules']</code></strong></li>
</ul>
<h3 style="color:green;text-decoration:underline;">Widget Summary</h3>
<ul>
    <li>Weaver X-Plus Menu - add menus in a widget</li>
    <li>Weaver X-Plus Link Buttons - show buttons in widget</li>
    <li>Weaver X-Plus Social Buttons - show social buttons in widget</li>
</ul>
<h3 style="color:green;text-decoration:underline;">Release Notes</h3>
<pre>
= Version 1.1 =
* New: Mega Menu Support
* New: SmartMenus alternative menu support
* New: support for compatible Weaver II Pro shortcodes
* New: additional background-xxx option field for BG Images
* Tweak: Mobile menu icon
* Fix: handling of empty button definitions
* Fix: style bug in [search]
* Fix: Per Post t/b padding value fixed
* Fix: Extra Menu right HTML display
* Fix: Deletion of added fonts could cause difficulties if try to re-add same font
* Fix/WARNING: The previous version of the CloudFlare plugin (if you use the CloudFlare service)
  had a bug that might have corrupted any .wxall or .wxfonts saved settings files. This Cloud Flare
  bug could also corrupt other saved settings that happen to contain a string like
  "href='http://example.com'". If you happen to have a corrupted settings file, it will not
  load properly, but will not change any current settings. We suggest that you save new copies of
  your settings.

= Version 1.2 =
* New: Post Header Injection area
* New: Per Post Desktop and Mobile BG Images
* New: Parallax support via Per Post options
* New: Per Page add classes to selected wrapping areas
* Fix: Background Image Additional CSS option - worked, but generated erroneous error message
</pre>
</div>
<?php
}

/*
    ================= nonce helpers =====================
*/
function weaverxplus_submitted($submit_name) {
    // do a nonce check for each form submit button
    // pairs 1:1 with weaverxplus__nonce_field
    $nonce_act = $submit_name.'_act';
    $nonce_name = $submit_name.'_nonce';

    if (isset($_POST[$submit_name])) {
	if (isset($_POST[$nonce_name]) && wp_verify_nonce($_POST[$nonce_name],$nonce_act)) {
	    return true;
	} else {
	    die("WARNING: invalid form submit detected ($submit_name). Probably caused by session time-out, or, rarely, a failed security check. Please contact WeaverTheme.com if you continue to receive this message.");
	}
    } else {
        return false;
    }
}

// admin helpers

function weaverxplus_nonce_field($submit_name,$echo = true) {
    // pairs 1:1 with sumbitted
    // will be one for each form submit button

    return wp_nonce_field($submit_name.'_act',$submit_name.'_nonce',$echo);
}

/*
    ================= form helpers =====================
*/

function weaverxplus_form_checkbox($id, $desc, $br = '<br />') {
?>
    <div style = "display:inline-block;padding-left:2.5em;text-indent:-1.7em;"><label><input type="checkbox" name="<?php echo $id ?>" id="<?php echo $id; ?>"
        <?php checked(weaverxplus_getopt($id) ); ?> >&nbsp;
<?php   echo $desc . '</label></div>' . $br . "\n";
}

//======================= runtime support: shortcode code ===============
require_once(dirname( __FILE__ ) . '/weaver_xplus_social.php'); // NOW - load the admin stuff
//if (!weaverxplus_getopt('_wii_hide_shortcoder'))	// Shortcoder
require_once(dirname( __FILE__ ) . '/weaver_xplus_code_shortcoder.php');
?>
