<?php
/* -------------- widget_area --------------- */
function weaverxplus_widget_area_shortcode($args = '') {
	/* implement [widget_area id='name'] shortcode */

	extract(shortcode_atts(array(
		'area' => '#',
		'class' => '',
        'area_style' => 'widget',
		'style' => ''
	), $args));

    // widget-area widget-area-footer l-widget-area-footer m-widget-area-footer s-widget-area-footerwidget-cols-3 widget-smart-rm border s-font-size font-consolas
    //real footer: widget-area widget-cols-3 widget-smart-rm border s-font-size font-consolas

	unset( $GLOBALS['wvr_widget_number']);     // clear for each widget
	$GLOBALS['wvr_widget_number'] = false;

    $styles = array('top', 'bottom', 'primary', 'secondary', 'header', 'footer');

    $class = trim("widget-area widget-area-{$area_style} l-widget-area-{$area_style} m-widget-area-{$area_style} s-widget-area-{$area_style} " . trim($class) . ' ');

    if ( $style )
        $style = ' style=' . bracket($style, '"', '"');

    if (in_array( $area_style, $styles ) ) {
        $thestyle = $area_style;
        if ( in_array($area_style,array('footer','header') ) )
            $thestyle = $thestyle . '_sb';
        $class .= ' ' . weaverx_area_class( $thestyle, 'pad' );
        $class = trim( $class );
    } else {
        $area_style = 'widget';
    }

	$area = 'per-page-' . $area;  // retrieve meta value
	$bad = '<h3>[widget_area] - Area ' . $area . ' not defined.</h3>';
	$id_tag = 'extra-widget-x' . weaverx_generate_id();


	$content = "<div id=\"{$id_tag}\" class=\"{$class}\" {$style}>\n";

	if (strlen($area) > 0) {              // want to display some areas
		if ( !is_active_sidebar($area)) return $bad;
        weaverx_t_set('use_widget_area', $area_style );

		ob_start();
		$success = dynamic_sidebar($area);
		$content .= ob_get_clean();
		if ($success && $content) {
			$content .= "\n</div>\n";
		} else {
			$content = $bad;
		}
	}

	return $content;
}

function bracket($txt,$head,$tail){
    $lead = strpos($txt, $head);
    if ($lead === false || $lead != 0)
        $txt = $head . $txt;
    $end = strrchr($txt, $tail);
    if ($end === false || strlen($end) > 1)
        $txt = $txt . $tail;
    return $txt;
}

add_shortcode('widget_area', 'weaverxplus_widget_area_shortcode');

// ------------------------------ weaverx_showhide ------------------------------------------

function weaverxplus_has_img($img) {
	if (stristr($img,'.png') || stristr($img,'.gif') || stristr($img,'.jpg'))
		return true;
	else
		return false;
}

function weaverxplus_showhide_shortcode($args = '', $text) {

	extract(shortcode_atts(array(
	   'start' => 'hide',      // 'hide' or 'show'
	   'show' => '',
	   'hide' => '',
	   'class' => ''
	), $args));

	$rand = "sh_".rand();
	$url = weaverx_relative_url('assets/images/theme/');

	$is_img = 'img';

	$text = do_shortcode($text);    // allow nested shortcodes

	if ($show == '') {
		$show = $url . 'show.png';
		$show_img = '<img src="' . $show . '" alt="show" />';
	} else if (weaverxplus_has_img($show)) {
		$show_img = '<img src="' . $show . '" alt="show" />';
	} else {
		$is_img = 'text';
		$show_img = '<span class="weaverx_showhide_show">' . $show . '</span>';   // text only
	}

	if ($hide == '') {
		$hide = $url . 'hide.png';
		$hide_img = '<img src="' . $hide . '" alt="hide" />';
	} else if (weaverxplus_has_img($hide)) {
		$hide_img = '<img src="' . $hide . '" alt="hide" />';
	} else {
		$is_img = 'text';
		$hide_img = '<span class="weaverx_showhide_hide">' . $hide . '</span>';   // text only
	}

	if ($start == 'hide') {
		$style = 'style="display:none;"';
	} else {
		$style = 'style="display:block;"';
		$show_img = $hide_img;
	}

	if ($class != '') {
		if ($class[0] == '.') $class = substr($class,1);
		$class = 'class="' . $class . '"';
	}

	$out = "<a style='text-decoration:none;' href=\"javascript:void(null);\" onclick=\"weaverx_ToggleDIV(document.getElementById('" .
		$rand . "'), this, '" . $show . "', '" . $hide . "', '" . $is_img . "')\">";

	$lead = stripos($text,'</p>');

	if ($lead !== false && $lead == 0) { // have </p> to start, so can break
		$out .= $show_img . '</a></p>';
		$text = substr($text,4);        // strip the </p>
		$out .= '<div id="'. $rand . '"' . $style .  ' ' . $class . '>';
		$out .= $text;
		$out .= "</p></div><p>";
	} else {                            // no paragraph - so make inline
		$out .= $show_img . '</a>';
		$has_p = stripos($text,'</p>');
		if ($has_p > 0) {
			$out .= '</p>'; // after the </a> to make span work
		}
		$out .= '<span id="'. $rand . '" ' . $style . ' ' . $class . '>';
		if ($has_p > 0) {
			$out .= '<p>'; // to make span work
			$lead_br = stripos($text,'<br />');
			if ($lead_br !== false && $lead_br == 0)
				$text = substr($text,6);
		}
		$out .= $text;

		if ($has_p !== false) {
			if ($has_p > 0)
				$out .= "</p></span><p>";
			else
				$out .= "</p></span>";
		} else {
			$out .= "</span>";
		}
	}

	return $out;
}

add_shortcode('showhide', 'weaverxplus_showhide_shortcode');

// ------------------------------ php ---------------------------------------

function weaverxplus_php_do_eval($code) {
	$char_codes = array( '&#8216;', '&#8217;', '&#8220;', '&#8221;', '&#8242;', '&#8243;', '&#8211;', '&#8212;', '&#8230;', '&#215;' );
	$replacements = array( "'", "'", '"', '"', "'", '"', '--', '---', '...', 'x' );
	$php = str_replace( $char_codes, $replacements, $code );    // untexturize

	$php  .= ';';

	$err_level = error_reporting(0);
	$out = '';
	ob_start();

	if(version_compare(PHP_VERSION, '5.0.0', '>')) {
	   try { eval($php); } catch(Exception $e) {}
	} else {
		eval($php);
	}

	$out .= ob_get_clean();
	error_reporting($err_level);
	return $out;
}

function weaverxplus_php_shortcode($args = '', $code) {
    if ( !weaverxplus_getopt('wvrxp_enable_p') )
        return '<strong>You first must enable [ php ] on the Xtreme Plus PHP admin tab.</strong>';

	return weaverxplus_php_do_eval($code);
}

add_shortcode('php', 'weaverxplus_php_shortcode');


/* -------------- popup_link --------------- */
function weaverxplus_popup_link_shortcode($args = '', $link) {
	/* implement [popup_link opt1="val1" opt2="value"]link-html[/popup_link] shortcode */

	extract(shortcode_atts(array(
		'href' => '#',
		'w' => '100',
		'h' => '100',
		'scrollbars' => false
	), $args));

	$link = do_shortcode($link);

	$sb = $scrollbars ? 'scrollbars=1,' : 'scrollbars=no,';

	$content = '<a href="' . $href . '" onClick="window.open(this.href,' .
	"'_blank','toolbar=no,location=no,directories=no,status=no,{$sb}resizable=no, menubar=no, width=$w,height=$h');return(false)\">$link</a>";
	return $content;
}

add_shortcode('popup_link', 'weaverxplus_popup_link_shortcode');


/* -------------- search --------------- */

function weaverxplus_search_shortcode($args = '') {
	extract(shortcode_atts(array(
        'button' => '',
        'class' => '',
        'max_width' => '90',
        'size' => '40'
	), $args));

    $out =
'<div class="' . trim("weaverx-plus-search {$class}") . '"><form style="display:inline;" role="search" method="get" class="search-form" action="' . esc_url( home_url( '/' ) ) . '">
	<label><span class="screen-reader-text">' . _x( 'Search for:', 'label' ) . '</span>
		<input style="max-width:' . $max_width . '%;" type="search" size=' . $size . ' class="search-field" placeholder="' . esc_attr_x( 'Search &hellip;', 'placeholder' ) . '" value="' . get_search_query() . '" name="s" title="' . esc_attr_x( 'Search for:', 'label' ) . '" />
	</label>';
    if ( $button )
        $out .= '<input type="submit" class="search-submit-plus" value="'. esc_attr_x( 'Search', 'submit button' ) .  '" />';

    $out .= '</form></div>';

	return $out;
}

weaverxplus_add_shortcode('search', 'weaverxplus_search_shortcode');




/* -------------- weaverxplus_feed --------------- */
function weaverxplus_feed_shortcode($args = '') {
	/* implement [weaver_feed feed='ur'] shortcode */

	extract(shortcode_atts(array(
		'feed' => '#',
		'show_sitename' => 1,
		'show_content' => 1,
		'excerpt' => false,
		'trusted' => false,
		'title_style' => '',
        'more_msg' => ' Click Article Title for full article at original site.',
		'items' => 10
	), $args));

	$err_msg = '[weaver_feed] invalid values provided.';

	$show_sitename = weaverxplus_tf($show_sitename);
	$show_content = weaverxplus_tf($show_content);
	$excerpt = weaverxplus_tf($excerpt);

    weaverx_t_clear_all();
	weaverx_t_set('more_msg',$more_msg);

	if ($title_style != '') {
		$title_style = 'style=' . weaverxplus_bracket($title_style, '"', '"');
	}

	$ent_title = '<header class="entry-header"><div class="entry-hdr"><h2 class="entry-title" ' . $title_style .'>';

	while ( stristr($feed, 'http') != $feed )   // strip anything before http
		$feed = substr($feed, 1);

	if ( empty($feed) )
		return $err_msg;

	// self-url destruction sequence
	if ( $feed == site_url() || $feed == home_url() )
		return '[weaver_feed] - feed must not be own site.';

	$rss = fetch_feed($feed);
	$sitedesc = '';
	$sitelink = '';

	if ( ! is_wp_error($rss) ) {
		$sitedesc = esc_attr(strip_tags(@html_entity_decode($rss->get_description(), ENT_QUOTES, get_option('blog_charset'))));
		$sitetitle = esc_html(strip_tags($rss->get_title()));
		$sitelink = esc_url(strip_tags($rss->get_permalink()));
		while ( stristr($sitelink, 'http') != $sitelink )
			$sitelink = substr($sitelink, 1);
	} else {
		if ( is_admin() || current_user_can('edit_theme_options') )
			$err_msg = '<p>' . sprintf( __('<strong>RSS Error</strong>: %s','weaver-ii'), $rss->get_error_message() ) . '</p>';
		return $err_msg;
	}

	if ( empty($sitetitle) )
		$sitetitle = empty($sitedesc) ? __('Unknown Feed','weaver-ii') : $sitedesc;

	$feed = esc_url(strip_tags($feed));

	if ( $sitetitle ) {
		$sitetitle = '<h2 class="entry-title feed-title">'
		. '<a href="' . $feed . '" title="' . esc_attr(__( 'Syndicate this content', 'weaverx' )) . '" target=\"_blank\"><span class="genericon genericon-feed"></span></a>&nbsp;&nbsp;'
		. "<a href='$sitelink' title='$sitedesc' target='_blank'>$sitetitle</a></h2>";
	}

	$out = "<div class='weaver-feed'> <!-- *********************************************** -->\n";
	if ($show_sitename) {
		$out .= $sitetitle . "\n";     // add a title for whole feed
	}

	$items = (int) $items;
	if ( $items < 1 || 20 < $items )
			$items = 10;

	if ( !$rss->get_item_quantity() ) {
		$out .= '<p>' . __( 'An error has occurred; the feed is probably down. Try again later.','weaver-ii') . '</p></div>';
		$rss->__destruct();
		unset($rss);
		return $out;
	}
	$rss_items = $rss->get_items(0, $items);

	// +++++++++++ feed article loop ++++++++++++

	foreach ( $rss_items as $item ) {
		$out .= '<article class="post type-post hentry category-uncategorized post-feed">' . "\n";

		$link = $item->get_link();
		while ( stristr($link, 'http') != $link )
			$link = substr($link, 1);
		$link = esc_url(strip_tags($link));
		$title = esc_attr(strip_tags($item->get_title()));
		if ( empty($title) )
			$title = __('Untitled','weaver-ii');

		$desc = @html_entity_decode( $item->get_description(), ENT_QUOTES, get_option('blog_charset') );
		if (!$trusted) {
			$desc = str_replace( array("\n", "\r"), ' ', esc_attr( strip_tags( $desc ) ) );
		}

		if ($excerpt) {
			$desc = wp_html_excerpt( $desc, 300 );

			// Append ellipsis. Change existing [...] to [&hellip;].
			if ( '[...]' == substr( $desc, -5 ) )
				$desc = substr( $desc, 0, -5 ) . '[&hellip;]';
			elseif ( '[&hellip;]' != substr( $desc, -10 ) )
				$desc .= ' [&hellip;]';
            $desc .= ' ' . $more_msg;
		}

		if (!$trusted)
			$desc = esc_html( $desc );

        $desc = str_replace('Continue reading', $more_msg, $desc);

		$date = '';
		$date = $item->get_date( 'U' );
		if ( $date ) {
			$date = date_i18n( get_option( 'date_format' ), $date );
		}

		$author = $item->get_author();
		if ( is_object($author) ) {
			$author = $author->get_name();
			$author = esc_html( strip_tags( $author ) );
		} else {
			$author = '';
		}

		if ( $link == '' ) $link = '#';

		$out .= $ent_title . '<a href="' . $link . '" title="Permalink to ' . $title . '">' . $title . "</a></h2></div>\n";

		// now match logic for posted_on
		$out .= weaverxplus_posted_on_code($date, $author) . "</header> <!-- entry-header -->\n";

		if ($show_content) {
			$out .= "<div class='entry-content'>\n" . $desc . "\n</div> <!-- entry-content -->\n";
		}

		$out .= "</article> <!-- post-feed -->\n";
	}
	$out .= "</div> <!-- weaver-feed -->\n";
	$rss->__destruct();
	unset($rss);
    weaverx_t_clear_all();
	return $out;
}

function weaverxplus_posted_on_code($date, $author) {

		$leftm = '8';

		$on = "\t<div class=\"entry-meta\" style=\"margin-botom:-5px;margin-top:-10px;\"><div " . weaverx_meta_info_class( 'post_info_top' ) . ">\n\t\t";

		$on .= '<span class="sep">Posted on </span><time class="entry-date" >' . $date .
			'<span class="by-author"> <span class="sep"> by </span> <span class="author vcard">' . $author . '</span></span>';
		$on .= "\n    </div></div><!-- .entry-meta -->\n";
		return $on;
}

function weaverxplus_tf($val) {
	if ($val === false) return false;
	if ($val == 'false') return false;
	if ($val == 'no') return false;
	if ((int)$val == 0) return false;
	return true;
}

weaverxplus_add_shortcode('feed', 'weaverxplus_feed_shortcode');




function weaverxplus_show_disclaimer() {
		$text = weaverxplus_getopt('disclaimer');
		if (!empty($text)) {
				echo('<div class="weaver-comment-disclaimer">'. do_shortcode($text) .'</div>');
		}
}
add_action('comment_form', 'weaverxplus_show_disclaimer', 99);


function weaverxplus_has_linkbuttons() {return true;}

define('WEAVERXPLUS_NUM_BUTTONS',8);

class weaverxplus_Widget_Buttons extends WP_Widget {

	function weaverxplus_Widget_Buttons() {
	   $widget_ops = array( 'classname'=>'weaverxplus_buttons',
		  'description' => __('Display Link Buttons as set in Weaver Xtreme Plus Link Buttons Shortcode Settings.','weaver-xtreme'));
	   parent::WP_Widget( 'weaverxplus_buttons', __('X-Plus Link Buttons','weaver-xtreme'), $widget_ops );
	}

   function widget($args, $instance) {
   // Get menu

	$instance['title'] = apply_filters('widget_title', $instance['title'], $instance, $this->id_base);
	$start = $instance['start'];
	$end = $instance['end'];
	$list = $instance['list'];

	echo $args['before_widget'];

	if ( !empty($instance['title']) )
	   echo $args['before_title'] . $instance['title'] . $args['after_title'];

	echo weaverxplus_buttons_generate_code($start,$end,$list);

	echo $args['after_widget'];
   }

   function update( $new_instance, $old_instance ) {
		$instance['title'] = strip_tags( stripslashes($new_instance['title']) );
		$instance['start'] = (int) $new_instance['start'];
		if ($instance['start'] < 1 ||  $instance['start'] > 64) $instance['start'] = 1;
		$instance['end'] = (int) $new_instance['end'];
		if ($instance['end'] < 1 ||  $instance['end'] > 64) $instance['start'] = 64;
		$instance['list'] = trim($new_instance['list']);

		return $instance;
   }

function form( $instance ) {
	$title = isset( $instance['title'] ) ? $instance['title'] : '';
	$start = isset($instance['start']) ? absint($instance['start']) : 1;
	$end = isset($instance['end']) ? absint($instance['end']) : 64;
	$list = isset( $instance['list'] ) ? $instance['list'] : '';

?>
			  <p>
			  <label for="<?php echo $this->get_field_id('title'); ?>"><?php echo('Title:' /*a*/ ) ?></label>
			  <input type="text" class="widefat" id="<?php echo $this->get_field_id('title'); ?>" name="<?php echo $this->get_field_name('title'); ?>" value="<?php weaverx_esc_textarea($title); ?>" />
			  </p>
			  <p><label for="<?php echo $this->get_field_id('start'); ?>">Start number:</label>
			  <input id="<?php echo $this->get_field_id('start'); ?>" name="<?php echo $this->get_field_name('start'); ?>" type="text" value="<?php weaverx_esc_textarea($start); ?>" size="3" />
			  </p>
			  <p><label for="<?php echo $this->get_field_id('end'); ?>">End number:</label>
			  <input id="<?php echo $this->get_field_id('end'); ?>" name="<?php echo $this->get_field_name('end'); ?>" type="text" value="<?php weaverx_esc_textarea($end); ?>" size="3" />
			  </p>
			  <p style="text-align:center;"><em>- or -</em></p>
			  <p><label for="<?php echo $this->get_field_id('list'); ?>">Comma separated list of numbers:</label>
			  <input id="<?php echo $this->get_field_id('list'); ?>" name="<?php echo $this->get_field_name('list'); ?>" type="text" value="<?php weaverx_esc_textarea($list); ?>" size="24" />
			  </p>

			  <p><em>Select Buttons to display from the Weaver Xtreme Plus Shortcodes menu. You can style with '.weaver-buttons'.</em>
			  </p>
<?php
   }
}


function weaverxplus_buttons_shortcode($args = '') {
   // [weaver_extra_menu menu='custom-menu-name' style='style-name']
	extract(shortcode_atts(array(
	   'start' => '1',   // range or list of values
	   'end' => '',
	   'list' => ''
	), $args));

	if ($end == '') {
	   if (weaverxplus_isset('buttons')) {
		  $buttons = weaverxplus_getopt('buttons');
		  if (isset($buttons['maxbuttons']))
			 $end = $buttons['maxbuttons'];
		  else
			 $end = weaverxplus_WEAVERXPLUS_NUM_BUTTONS;
	   }
	}
	$out = weaverxplus_buttons_generate_code($start,$end,$list);
	return $out;
}

function weaverxplus_buttons_generate_code($start=1, $end=64,$list='') {

	if (!weaverxplus_isset('buttons')) return 'No buttons defined.';
	$buttons = weaverxplus_getopt('buttons');
	$maxbuttons = $buttons['maxbuttons'];
	//echo '<pre>'; print_r($buttons); echo '</pre>';

	$out = '';

	if ($start < 1) $start = 1;                  // stay sane
	if ($end > $maxbuttons) $end = $maxbuttons;
	$out .= '<div class="weaver-buttons">';
	if ($list != '') {   // list specified - it has priority
	   $list_vals = explode(',',trim($list));
	   foreach ($list_vals as $item) {
		  $out .= weaverxplus_buttons_button($buttons,trim($item));
	   }
	} else {     // start:end
		 for ($i = $start ; $i <= $end ; $i++) {
			 $out .= weaverxplus_buttons_button($buttons,$i);
		 } // end for
	}

	$out .= '</div>' . "\n";

	return $out;
}



function weaverxplus_buttons_button($buttons,$i) {
   // code for one button
	$out = '';
	$btn_class = 'wvr-btn-' . $i;
	$i--;                // users start at 1, we start at 0
	$id = 'b'.$i;
	if ( !isset($buttons[$id.'_img_url']))
		return '';
	$img_url = $buttons[$id.'_img_url'];

	if ($img_url == '')
	   return $out;

	$title = $buttons[$id.'_hover'];
	$url = $buttons[$id.'_link_url'];
	if ($buttons[$id.'_blank']) $blank = ' target="_blank"';
	else $blank = '';


   if ($url != '')
	  $out .= '<a href="' . $url . '" title="' . $title . '"' . $blank . '>';

   $out .= '<img class="' . $btn_class . '" src="' . $img_url . '" title="'. $title . '" alt="' . $title .
	'" style="border:0;padding-right:3px;padding-bottom:3px;z-index:20;" />';

	// $out .= '<img class="btn-' . $i+1 . '" src="' . $img_url . '" title="'. $title . '" alt="' . $title .
	// '" style="border:0;padding-right:3px;padding-bottom:3px;z-index:20;" />';

   if ($url != '')
	  $out .= '</a>';
   $out .= "\n";
   return $out;
}

weaverxplus_add_shortcode('buttons','weaverxplus_buttons_shortcode');
/* ============================ weaverxplus_buttons =============================== */

add_action('widgets_init', "weaverxplus_load_buttons_widget");
function weaverxplus_load_buttons_widget() {
	register_widget("weaverxplus_Widget_Buttons");
}

//=========================== weaver II Pro compatibility ===========================

weaverxplus_add_shortcode('weaver_extra_menu','weaverxplus_extra_menu_shortcode');
weaverxplus_add_shortcode('weaver_buttons','weaverxplus_buttons_shortcode');
weaverxplus_add_shortcode('weaver_sc', 'weaverxplus_sc_shortcode');
weaverxplus_add_shortcode('weaver_social','weaverxplus_social_shortcode');
weaverxplus_add_shortcode('weaver_feed', 'weaverxplus_feed_shortcode');
weaverxplus_add_shortcode('weaver_php', 'weaverxplus_php_shortcode');
weaverxplus_add_shortcode('weaver_popup_link', 'weaverxplus_popup_link_shortcode');
weaverxplus_add_shortcode('weaver_search', 'weaverxplus_search_shortcode');
weaverxplus_add_shortcode('weaver_showhide', 'weaverxplus_showhide_shortcode');
weaverxplus_add_shortcode('aspen_showhide', 'weaverxplus_showhide_shortcode');
weaverxplus_add_shortcode('weaver_widget_area', 'weaverxplus_widget_area_shortcode');

// === incompatible shortcodes...
function weaverxplus_gadget_shortcode($args) {
	return '<strong>&#91;weaver_gadget] Weaver II Pro shortcode not supported by Weaver Xtreme Plus.</strong>';
}
function weaverxplus_slider_shortcode($args) {
	return '<strong>&#91;weaver_slider] Weaver II Pro shortcode not supported by Weaver Xtreme Plus.</strong>';
}
weaverxplus_add_shortcode('weaver_gadget','weaverxplus_gadget_shortcode');
weaverxplus_add_shortcode('weaver_slider','weaverxplus_slider_shortcode');
?>
